'-------------------------------------------------------------------------------
'UNO_Ohm.BAS
'-------------------------------------------------------------------------------
$regfile = "m328pdef.dat"                                   'ATmega328p
$crystal = 16000000                                         '16 MHz
$baud = 9600
$hwstack = 32
$swstack = 32
$framesize = 64

Dim Count As Word
Dim Resistance As Word
Dim F As Single
Dim Humidity As Word

Led1 Alias Portc.2
Led2 Alias Portb.2
S1 Alias Pinc.0
S2 Alias Pinc.1
Portc.0 = 1                                                 'Pullup
Portc.1 = 1
Config Led1 = Output
Config Led2 = Output

Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portd.3 , Rs = Portd.2
Config Lcd = 16 * 2
Cls
Cursor Off


Do
  Count = 0
  Portb.3 = 1
  Ddrb.3 = 1                                                'Charge
  Waitms 500
  Portb.3 = 0                                               'Discharge
  Waitus 10
  Ddrb.3 = 0
  Do
    Count = Count + 1                                       'Counter
  Loop Until Pinb.3 = 1 Or Count.15 = 1
  Portb.3 = 1
  Ddrb.3 = 1
  Print Count
  Locate 1 , 1
  Lcd Count
  Lcd "       "


  'Calculate Resistance
  If Count > 4 Then Count = Count - 4 Else Count = 0        '-1 kOhm
  Resistance = Count * 14
  Resistance = Resistance / 40
  Print Resistance                                          '...kOhm
  Locate 2 , 1
  Lcd Resistance
  Lcd " kOhm  "

  'Calculate Humidity
  F = Count
  F = Log(f)
  F = F * 8.9
  F = 103 - F
  Humidity = Round(f)
  Locate 1 , 6
  Lcd Humidity
  Lcd "%       "
Loop

End