'-------------------------------------------------------------------------------
'UNO_LCD2.BAS  Gamma Shield A0
'-------------------------------------------------------------------------------
$regfile = "m328pdef.dat"                                   'ATmega328p
$crystal = 16000000                                         '16 MHz
$baud = 9600

Dim D As Word
Dim U As Single
Dim N As Word

Config Adc = Single , Prescaler = 64 , Reference = Avcc     '5 V

Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portd.3 , Rs = Portd.2
Config Lcd = 16 * 2

Cls
Cursor Off
Lcd "Gamma"
N = 0
Do
  D = Getadc(0)                                             'LED
  Ddrc.0 = 1
  Waitms 1
  Ddrc.0 = 0
  If D > 30 Then
    ' D = D / 4
    Print Chr(d);
    U = D * 5.0
    U = U / 1023
    Locate 1 , 1
    Lcd U
    Lcd "    "
    N = N + 1
    Locate 2 , 1
    Lcd N
  End If
  Waitms 100
Loop